import static com.mathieubolla.externalui.uibuilder.Input.input;
import static com.mathieubolla.externalui.uibuilder.Output.output;
import static com.mathieubolla.externalui.uibuilder.Line.line;
import static com.mathieubolla.externalui.uibuilder.UIBuilder.with;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import com.mathieubolla.externalui.ExternalUiProvider;
import com.mathieubolla.externalui.events.Event;
import com.mathieubolla.externalui.events.EventListener;
import com.mathieubolla.externalui.utils.StreamProvider;

public class Sample {
	private static String currentString = "";
	
	private static final StreamProvider KEYBOARD_UI = with(//
			line(1, //
				output(1, "<current string>", "status1"),
				output(1, "<time>", "status2")
				),
			line(1, //
				input(1, "event", "A", "A"),//
				input(1, "event", "B", "B"),//
				input(1, "event", "C", "C"),//
				input(1, "event", "D", "D"),//
				input(1, "event", "E", "E")//
				),//
			line(1, //
				input(1, "event", "F", "F"),//
				input(1, "event", "G", "G"),//
				input(1, "event", "H", "H"),//
				input(1, "event", "I", "I"),//
				input(1, "event", "J", "J")//
				),//
			line(1, //
				input(1, "event", "K", "K"),//
				input(1, "event", "L", "L"),//
				input(1, "event", "M", "M"),//
				input(1, "event", "N", "N"),//
				input(1, "event", "O", "O")//
				),//
			line(1, //
				input(1, "event", "P", "P"),//
				input(1, "event", "Q", "Q"),//
				input(1, "event", "R", "R"),//
				input(1, "event", "S", "S"),//
				input(1, "event", "T", "T")//
				),//
			line(1, //
				input(1, "event", "U", "U"),//
				input(1, "event", "V", "V"),//
				input(1, "event", "W", "W"),//
				input(1, "event", "Y", "X"),//
				input(1, "event", "Y", "Y"),//
				input(1, "event", "Z", "Z")//
				),//
			line(1,//
				input(2, "control", "clear", "Clear all"),//
				input(1, "control", "backspace", "<-"),//
				input(1, "control", "space", "< >")//
				)
			);
	
	public static void main(String[] args) {
		ExternalUiProvider externalUiProvider = new ExternalUiProvider(8080, KEYBOARD_UI);

		externalUiProvider.register(dumpToConsoleListener(externalUiProvider));
		externalUiProvider.register(clearListener(externalUiProvider));
		sendTimeEverySecondTo(externalUiProvider);
	}

	private static void sendTimeEverySecondTo(final EventListener listener) {
		new Timer().scheduleAtFixedRate(new TimerTask() {
			@Override
			public void run() {
				listener.notify(new Event("status2", new SimpleDateFormat("HH:mm:ss").format(new Date())));
			}
		}, 1000 - (System.currentTimeMillis() % 1000), 1000);
	}

	private static EventListener dumpToConsoleListener(final EventListener listener) {
		return new EventListener() {
			@Override
			public void notify(Event event) {
				if ("event".equals(event.getCode())) {
					currentString += event.getValue();
					listener.notify(new Event("status1", currentString));
				}
			}
		};
	}

	private static EventListener clearListener(final EventListener listener) {
		return new EventListener() {
			@Override
			public void notify(Event event) {
				if ("control".equals(event.getCode())) {
					if ("clear".equals(event.getValue())) {
						currentString = "";
					} else if ("backspace".equals(event.getValue())) {
						currentString = currentString.substring(0, currentString.length()-1);
					} else if ("space".equals(event.getValue())) {
						currentString += " ";
					}
					listener.notify(new Event("status1", currentString));
				}
			}
		};
	}
}
