import static com.mathieubolla.externalui.uibuilder.Input.input;
import static com.mathieubolla.externalui.uibuilder.Line.line;
import static com.mathieubolla.externalui.uibuilder.Output.output;
import static com.mathieubolla.externalui.uibuilder.UIBuilder.with;

import java.util.Timer;
import java.util.TimerTask;

import com.mathieubolla.externalui.ExternalUiProvider;
import com.mathieubolla.externalui.events.Event;
import com.mathieubolla.externalui.events.EventListener;
import com.mathieubolla.externalui.utils.StreamProvider;

public class Sample2 {
	private static final Timer timer = new Timer();
	private static final StreamProvider UI = with(//
		line(1, //
			output(1, "<memory>", "memory"),//
			input(1, "command", "quit", "Quit")
		)
	);
	
	public static void main(String[] args) {
		final ExternalUiProvider provider = new ExternalUiProvider(8080, UI);
		
		timer.schedule(new TimerTask() {
			@Override
			public void run() {
				provider.notify(new Event("memory", ""+Runtime.getRuntime().freeMemory()));
			}
		}, 1000, 1000);
		
		provider.register(new EventListener() {
			@Override
			public void notify(Event event) {
				if ("command".equals(event.getCode())) {
					if ("quit".equals(event.getValue())) {
						System.exit(0);
					}
				}
			}
		});
	}
}
