package com.mathieubolla.externalui.uibuilder;

public class Input extends Element {
	private final String type;
	private final String value;
	private final String display;

	public Input(int blockCount, String type, String value, String display) {
		super(blockCount);
		this.type = type;
		this.value = value;
		this.display = display;
	}
	
	public String render(int spaceInPercent) {
		return "<div style=\"width:"+spaceInPercent+"%;height:100%;background-color:#AAAAAA;border-radius:0.5em;border-width:1px;border-color:#555555;float:left\" onClick=\"send('"+type+"', '"+value+"');\">"+display+"</div>";
	};
	
	public static Input input(int size, String type, String value, String display) {
		return new Input(size, type, value, display);
	}
}
